import xml.etree.ElementTree as xml
import json
import sys, codecs

mistakes = {}
authors = {}

alias = {}
fd = codecs.open("alias.txt", "r", "UTF-8")
for line in fd.readlines():
    if line[0] != "#":
        line = line.strip()
        x = line.split(":")
        main = x[0];
        for a in x[1:]:
            alias[a] = main
fd.close()    

#fn = codecs.open("firstnames.txt" , "w", "UTF-8")
#firstnames = {}

def findMistake(full, first, last):
    if not full in authors:
        if full in mistakes:
            print >>sys.stderr, "Inversion exists for ", full
        else:
            mistakes[first+", "+last] = True
            authors[full] = {}
#    if not first in firstnames:
#        firstnames[first] = True
#        print >> fn, first
    return full

def fullName(first, last):
    full = last+", "+first
    if full in alias:
        full = alias[full]
    else:
        full = findMistake(full, first, last)
    return full

doc = xml.ElementTree()
doc.parse(sys.argv[1])

def shortName(first, last):
    if first.find(' ') >= 0:
        first = ". ".join([n[0].upper() for n in first.split(' ')])+"."
    else:
        first = ".-".join([n[0].upper() for n in first.split('-')])+"."
    if last in alias:
        last = alias[last]
    return (last+", "+first) #.replace(" ", "_")

def addEdge(s,t):
    if s not in authors:
        authors[s] = {}
    targets = authors[s]
    targets[t] = True
    if t not in authors:
        authors[t] = {}
    targets = authors[t]
    targets[s] = True

for node in doc.getroot():
    names = []
    for a in node.findall("authors/author"):
        last = a.findtext("lastname")
        first = a.findtext("firstname")
        name = fullName(first, last)
        names.append(name)
    for s in range(len(names)-1):
        for t in range(s+1,len(names)):
            addEdge(names[s],names[t])

for s in authors:
    for t in authors[s]:
        print s.encode('UTF-8')+";"+t.encode('UTF-8')
